#include "animation.h"
#include <string>

using namespace std;

Animation::Animation()
{
	startTick = 0;
	frames = 0;
}

Animation::~Animation()
{
}

int Animation::Width(void)
{
	return pict.Height();	// yes, height
}

int Animation::Height(void)
{
	return pict.Height();
}

void Animation::Load(const char *path)
{
	pict.Load((string(path) + string("/image.png")).c_str());
	frames = pict.Width() / pict.Height();
}

void Animation::SetStartTick(int startTick)
{
	this->startTick = startTick;
}

void Animation::Blit(SDL_Surface* dest, int x, int y, int tick, int alpha)
{
	SDL_Rect s, d;

	int frame = ((tick - startTick) / 100) % frames;

	s.x = frame * pict.Height(); s.y = 0; s.w = pict.Height(); s.h = pict.Height();
	d.x = x; d.y = y; d.w = 0; d.h = 0;

	pict.Blit(dest, &s, &d, alpha);
}

void Animation::Blit(Picture& dest, int x, int y, int tick, int alpha)
{
	SDL_Rect s, d;

	int frame = ((tick - startTick) / 100) % frames;

	s.x = frame * pict.Height(); s.y = 0; s.w = pict.Height(); s.h = pict.Height();
	d.x = x; d.y = y; d.w = 0; d.h = 0;

	pict.Blit(dest, &s, &d, alpha);
}
