#ifndef __CHANNEL_H__
#define __CHANNEL_H__

#include "defines.h"
#include "SDL.h"
#include "file.h"
#include <vorbis/codec.h>
#include <vorbis/vorbisfile.h>

#include <string>
using namespace std;

#define MUSIC_CHANNEL_BUFFER_SIZE 1024

class MusicChannel
{
	public:

	MusicChannel();
	virtual ~MusicChannel();

	MusicChannel(const MusicChannel& f);
	MusicChannel& operator=(const MusicChannel& f);

	void FillBuffer(BYTE *data, int count);

	void Unload(void);
	void Load(string name, bool loop);

	void SetVolume(int volume);
	int GetVolume(void);
	bool IsLoaded(void);

	protected:

	SDL_mutex* mux;

	bool loaded;
	string name;

	int volume;
	bool loop;

	BYTE *buffer;
	unsigned int bufferSize, bufferPtr;
	int currentSection;

	File fl;
	OggVorbis_File vf;
};

#endif /* __CHANNEL_H__ */
