// #include <windows.h>
#include "defines.h"

#ifndef LOGFILE_NAME
	#define LOGFILE_NAME "debuglog.log"
#endif

double sqq(double n)
{
	return (n * n);
}

int sgn(int a)
{
	return ( (a==0) ? 0 : ((a>0) ? 1 : (-1)) );
}

char hex[17] = "0123456789ABCDEF";

int unhex(char c)
{
	switch (c)
	{
		case '0': return 0;
		case '1': return 1;
		case '2': return 2;
		case '3': return 3;
		case '4': return 4;
		case '5': return 5;
		case '6': return 6;
		case '7': return 7;
		case '8': return 8;
		case '9': return 9;

		case 'a':
		case 'A': return 10;

		case 'b':
		case 'B': return 11;

		case 'c':
		case 'C': return 12;

		case 'd':
		case 'D': return 13;

		case 'e':
		case 'E': return 14;

		case 'f':
		case 'F': return 15;

		default: return 0;
	}
}

int addLogFirst = 1;

void AddLog(const char *fmt, ...)
{
	va_list argptr;
	char buf[0x800];
	FILE *fp;

	va_start(argptr, fmt);
	vsprintf(buf, fmt, argptr);
	va_end(argptr);

	if (addLogFirst)
	{
		fp = fopen(LOGFILE_NAME, "wb");
		addLogFirst = 0;
	}
	else fp = fopen(LOGFILE_NAME, "ab");

	if (fp != NULL)
	{
		fprintf(fp, "%s\n", buf);
		fclose(fp);
	}
}

void AddLogN(const char *fmt, ...)
{
	va_list argptr;
	char buf[0x800];
	FILE *fp;

	va_start(argptr, fmt);
	vsprintf(buf, fmt, argptr);
	va_end(argptr);

	if (addLogFirst)
	{
		fp = fopen(LOGFILE_NAME, "wb");
		addLogFirst = 0;
	}
	else fp = fopen(LOGFILE_NAME, "ab");

	if (fp != NULL)
	{
		fprintf(fp, "%s", buf);
		fclose(fp);
	}
}

void Error(const char *fmt, ...)
{
	va_list argptr;
	char buf[0x800];

	va_start(argptr, fmt);
	vsprintf(buf, fmt, argptr);
	va_end(argptr);

	printf("[Error] %s\n", buf);
	AddLog("[Error] %s", buf);
	exit(1);
}

char* AllocNstrcpy(const char *str)
{
	char *s;

	s = new char[strlen(str)+1];
	strcpy(s, str);

	return s;
}
