#include "failhandle.h"

#include "defines.h"
#include <stdio.h>
#include <fcntl.h>

FailHandle::FailHandle(FailSystem* fs)
{
	this->fs = fs;
	initEncOff = -1;
}

FailHandle::~FailHandle()
{
}

long FailHandle::Seek(long off, int whence)
{

	switch (whence)
	{
		case FH_CUR:
			{
				long curr = lseek(handle, 0L, SEEK_CUR) - offset;
				off = curr + off;
			}
			break;

		case FH_END:
			off = size - off;
			break;
	}

	if (off < 0) off = 0;
	if (off > size) off = size;

	if (initEncOff == -1) initEncOff = encOff;
	encOff = fs->NormalizeEncOff(initEncOff + off);

	lseek(handle, off + offset, SEEK_SET);
	return off;
}

long FailHandle::Read(void* buffer, unsigned int size)
{
	unsigned long sz = read(handle, buffer, size);
	if (sz) encOff = fs->Decrypt(encOff, buffer, sz);
	return sz;
}

void FailHandle::Write(void* buffer, unsigned int size)
{
	throw Exception("Writing to FAIL system not supported.");
}
