#ifndef __FAILSYSTEM_H__
#define __FAILSYSTEM_H__

#include "filesystem.h"

#include <string>
#include <list>

using namespace std;

class FailSystem : public FileSystem
{
	public:

	struct FailEntry
	{
		string name;
		unsigned long offset;
		unsigned long size;
		int encOff;
	};

	FailSystem();
	virtual ~FailSystem();

	int NormalizeEncOff(int encOff);
	int Decrypt(int encOff, void* data, unsigned int size);
	void InitFS(const char* arcName);

	FileHandle* GetHandle(const char* filename, int mode);
	void CloseHandle(FileHandle* fh);

	protected:

	bool alreadyInit;
	int encSz;
	list<FailEntry> files;
	string currentArcName;
};

#endif /* __FAILSYSTEM_H__ */
