#ifndef __FILESYSTEM_H__
#define __FILESYSTEM_H__

#include "exception.h"
#include "filehandle.h"

#define FS_READ 1
#define FS_WRITE 2

class FileSystem
{
	public:

	FileSystem()
	{
	}

	virtual ~FileSystem()
	{
	}

	FileSystem(const FileSystem& f)
	{
		throw Exception("Copy FileSystem object not allowed (construct)");
	}

	FileSystem& operator=(const FileSystem& f)
	{
		throw Exception("Copy FileSystem object not allowed (operator=)");
	}

	virtual FileHandle* GetHandle(const char* filename, int mode) = 0;
	virtual void CloseHandle(FileHandle* fh) = 0;
};

#endif /* __FILESYSTEM_H__ */
