#ifndef __FONT_H__
#define __FONT_H__

#include "picture.h"
#include "file.h"
#include <SDL_ttf.h>

#include <list>

using namespace std;

class Font
{
	public:

	Font();
	virtual ~Font();

	Font(const Font& f);
	Font& operator=(const Font& f);

	void Load(const char *path, unsigned int size, unsigned int renderstyle);
	void Blit(SDL_Surface* dest, int x, int y, char c, bool outline=false);
	void BlitRects(list<SDL_Rect>& rects, SDL_Surface* dest, int x, int y, char c, bool outline=false);
	// void Blit(Picture& dest, int x, int y, char c);
	int Width(char c);
	int Height(void);

	void SetColor(int c);
	void SetOutColor(int c);

	protected:

	File fl;
	TTF_Font* font;
	SDL_Color fgColor, outColor;
	int realHeight;
	int widths[0x100];
	RectsField rf;
};

#endif /* __FONT_H__ */
