#include <stdio.h>
#include "fsfactory.h"
#include "hostfilesystem.h"
#include "failsystem.h"

int FsFactory::fsType = HOST_FS;
int FsFactory::prevFsType = -1;
FileSystem* FsFactory::fs = NULL;

FsFactory::~FsFactory()
{
}

FileSystem* FsFactory::GetFileSystem(void)
{
	if (fs!=NULL && fsType!=prevFsType)
	{
		prevFsType = fsType;
		delete fs;
		fs = NULL;
	}

	if (fs == NULL)
	{
		switch (fsType)
		{
			case FOLD_FS:
				fs = new HostFileSystem(true);
				break;

			case FAIL_FS:
				fs = new FailSystem();
				break;

			default:
				fs = new HostFileSystem();
				break;
		}
	}

	return fs;
}

void FsFactory::SetFsType(int fsType)
{
	FsFactory::fsType = fsType;
}
