#ifndef __GLOBAL_H__
#define __GLOBAL_H__

#include <list>
#include "SDL.h"
#include "settings.h"

#define PIXEL(x, y) ((int*)screen->pixels)[(y) * (screen->pitch >> 2) + (x)]

#define CURSOR_ARROW 0
#define CURSOR_BUSY 1
#define CURSOR_HAND 2
#define CURSOR_LAST 3

extern SDL_Surface* screen;
extern SDL_Surface* screenBuffer;
extern SDL_Surface* screenSecondaryBuffer;
extern volatile bool updateScreen;
extern volatile unsigned int cursorShape;

extern volatile int mouseX, mouseY, mouseLB, mouseRB, key, ukey, kdir, tick;
extern volatile bool isActive;

extern bool updateAll;
extern std::list<SDL_Rect> updateList;

extern GameSettings settings, userSettings;
extern int enableSound;

void PollEvents(void);
void KeyPressed(void);
SDL_Rect DefRect(int x, int y, int w, int h);
void Clear(int c);
SDL_Surface* CopySurface(SDL_Surface *src);
SDL_Surface* LoadBitmap(const char* path);
void UpdateScreen(void);

bool FrameBegin(void);
void FrameEnd(bool useDelay = true);

#endif /* __GLOBAL_H__ */
