#include "hostfilesystem.h"
#include "hostfilehandle.h"

#include "defines.h"
#include <stdio.h>
#include <string.h>
#include <sys/stat.h>
#include <fcntl.h>

#ifndef FILES_PREFIX
	#define FILES_PREFIX "data/"
#endif

#ifndef O_BINARY
	#define O_BINARY 0
#endif

HostFileSystem::HostFileSystem()
{
	usePrefix = false;
}

HostFileSystem::HostFileSystem(bool usePrefix)
{
	this->usePrefix = usePrefix;
}

HostFileSystem::~HostFileSystem()
{
}

FileHandle* HostFileSystem::GetHandle(const char* filename, int mode)
{
	int handle = -1;
	char actname[MAX_PATH];

	if (usePrefix)
	{
		strcpy(actname, FILES_PREFIX);
		strcat(actname, filename);
	}
	else strcpy(actname, filename);

	switch (mode)
	{
		case FS_READ:
			handle = open(actname, O_BINARY | O_RDONLY);
			break;

		case FS_WRITE:
			handle = open(actname, O_CREAT | O_BINARY | O_TRUNC | O_WRONLY, S_IREAD | S_IWRITE);
			break;
	}

	if (handle == -1) return NULL;

	HostFileHandle* fh = new HostFileHandle();
	fh->handle = handle;

	return fh;
}

void HostFileSystem::CloseHandle(FileHandle* fh)
{
	close(((HostFileHandle*)fh)->handle);
	delete fh;
}
