#ifndef __FONT_H__
#define __FONT_H__

#include "picture.h"

class Font
{
	public:

	Font();
	virtual ~Font();

	void Load(const char *path);
	void Blit(SDL_Surface* dest, int x, int y, char c);
	void Blit(Picture& dest, int x, int y, char c);
	int Width(char c);
	int Height(void);

	void SetColor(int c);

	protected:

	bool alreadyInit;

	void InitSymbols(void);
	bool CheckNoTransp(int x);
	bool CheckRed(int x);
	int GetLBound(int x);
	int GetRedLine(int x);
	int GetRBound(int lx, int x);

	Picture fontPic;
	SDL_Rect symbols[0x100];

	static char availSymbols[];
};

#endif /* __FONT_H__ */
