#ifndef __PICTURE_H__
#define __PICTURE_H__

#include "defines.h"
#include "SDL.h"
#include "rectsfield.h"

#include <list>

using namespace std;

class Picture
{
	public:

	Picture();
	virtual ~Picture();

	Picture(const Picture& p);
	Picture& operator=(const Picture& p);

	int Width(void);
	int Height(void);

	void Clear(void);
	void Load(const char* path, bool ignoreAlpha=false);

	void Blit(SDL_Surface* dest, int x, int y, int alpha = 255);
	void Blit(SDL_Surface* dest, SDL_Rect *s, SDL_Rect *d, int alpha = 255);

	void Blit(Picture& dest, int x, int y, int alpha = 255);
	void Blit(Picture& dest, SDL_Rect *s, SDL_Rect *d, int alpha = 255);

	void BlitRects(list<SDL_Rect>& rects, SDL_Surface* dest, int x, int y, int alpha = 255);
	void BlitRects(list<SDL_Rect>& rects, SDL_Surface* dest, SDL_Rect *s, SDL_Rect *d, int alpha = 255);

	DWORD& Pixel(int x, int y);

	protected:

	bool CheckExt(const char* path, const char* ext);

	int width;
	int height;
	DWORD* data;
	RectsField rf;
};

#endif /* __PICTURE_H__ */
