#!/bin/sh

PROGNAME=project.namae.exe

rm $PROGNAME &> /dev/null
# g++ *.cpp -I/mingw/include/SDL -Dmain=SDL_main -D__gnu_cxx=ext -lmingw32 -lSDLmain -lvorbis -lvorbisfile -lSDL -o $PROGNAME &> errors.lst

g++ *.cpp \
	-o $PROGNAME \
	-I/mingw/include/SDL \
	-Dmain=SDL_main \
	-DLOGFILE_NAME=\"project.namae.log\" \
	-DSETTINGS_NAME=\"project.namae.settings\" \
	-D__gnu_cxx=ext \
	-lmingw32 \
	/mingw/lib/libpng.a \
	/mingw/lib/libz.a \
	/mingw/lib/libvorbisfile.a \
	/mingw/lib/libvorbis.a \
	/mingw/lib/libogg.a \
	/mingw/lib/libSDLmain.a \
	/mingw/lib/libSDL_ttf.a \
	/mingw/lib/libfreetype.a \
	-lSDL \
	-mwindows &> errors.lst

RETVAL=`cat errors.lst`

if [ "x$RETVAL" != "x" ] ; then
	cat errors.lst
else
	rm errors.lst
	./$PROGNAME
fi
