#ifndef __SETTINGS_H__
#define __SETTINGS_H__

#include <ext/hash_map>
#include <string>

#include "dict.h"

using namespace std;
using namespace ext;

class GameSettings
{
	public:

	GameSettings();
	virtual ~GameSettings();

	void Load(const char* path);
	int Get(const char *name, int defaultValue);

	protected:

	void SkipSpaces(void);

	bool IsValidSym(char c);
	bool IsNum(char c);
	bool IsHexNum(char c);

	string ReadName(void);
	string ReadPrefix(void);
	int ReadNumber(void);

	char *ptr;
	char buffer[0x1000];

	hash_map<string, int> values;
};

#endif /* __SETTINGS_H__ */
