#!/usr/bin/ruby

# Script.Converter (c) 2008 Amae.Namae

class ScriptConverter
	def say(name, text)
		name.gsub!(/"/, '""')
		text.gsub!(/"/, '""')

		btext = text

		loop do
			text.gsub!(/[ ]---/, '---')
			text.gsub!(/---[ ]/, '---')
			break if text==btext
		end

		if name == ''
			@ofl.write("say text=\"#{text}\"\n")
		else
			@ofl.write("say \"#{name}\", text=\"#{text}\"\n")
		end
	end

	def process_cond(cond)
		return cond.gsub(/==/, '=')
	end

	def process_label(label)
		if label.slice(0,1) == '#'
			label = label.slice(1, label.size-1).strip
		elsif label.slice(0,2) == '%%'
			label = '#' + label.slice(2, label.size-4).strip
		end

		return label
	end

	def command(cmd, params)
		if ['item','menu'].include?(cmd)
			@ofl.write("\n") if !@prev_menu
			@prev_menu = true
		else
			@ofl.write("\n") if @prev_menu
			@prev_menu = false
		end

		if cmd == 'set'
			arr = params.split(/[ ]/)

			if arr.size == 1
				@ofl.write("#{params.strip} = 1\n")
			elsif arr.size == 2
				@ofl.write("#{arr[0].strip} = \"#{arr[1].strip}\"\n")
			else
				@ofl.write("' [ERROR PROCESSING] @set #{params}\n")
			end

			return
		end

		if cmd == 'inc'
			params.split(/[ ]/).each do |param|
				@ofl.write(param.strip + ' = ' + param.strip + " + 1\n")
			end
			
			return
		end

		if cmd == 'gotorandom'
			pspl = params.split(/,/)
			@ofl.write('if rand(100)>50 ' + process_label(pspl[0].strip) + "\n")
			@ofl.write('goto ' + process_label(pspl[1].strip) + "\n")
			return
		end

		if ['bg','bgmusic','bgsound','sound'].include?(cmd) && params.slice(0,1)!='"'
			if cmd=='bg' && params=='black'
				params = 'none'
			elsif params == 'silence'
				params = 'none'
			else
				params = '"' + params + '"'
			end
		end

		if ['bgmusic','bgsound','sound'].include?(cmd)
			cmd = "' [TEMPORARY DISABLED] " + cmd
		end

		if cmd == 'gotoif'
			cmd = 'if'
			pspl = params.split(',')
			params = process_cond(pspl[0].strip) + ' ' + process_label(pspl[1].strip)
		end

		if cmd == 'goto'
			params = process_label(params)
		end

		if params == ''
			@ofl.write(cmd + "\n")
		else
			@ofl.write(cmd + ' ' + params + "\n")
		end
	end

	def do_convert(from)
		@prev_menu = false

		@ofl.write("' ---- file: #{from} ----\n\n")

		ifl = File.open(from, 'rb')

		while !ifl.eof
			line = ifl.readline.strip
			next if line == ''

			if line.slice(0,1) == '@'
				cmdline = line.slice(1, line.size-1)
				cmd = cmdline.split(/ /).first

				if cmd == 'include'
					if cmd.size != cmdline.size
						param = cmdline.slice(cmd.size+1, cmdline.size-cmd.size-1).strip
						param = param.slice(1, param.size-2) if param.slice(0,1) == '"'
						@ofl.write("\n")
						do_convert(param)
					else
						@ofl.write("' [ERROR PROCESSING] #{line}\n")
					end
				else
					if cmd.size == cmdline.size
						command(cmd, '')
					else
						command(cmd, cmdline.slice(cmd.size+1, cmdline.size-cmd.size-1).strip)
					end
				end
			elsif line.slice(0,1) == '#'
				@ofl.write("\n:" + line.slice(1, line.size-1).strip + "\n")
			elsif line.slice(0,2) == '//'
				@ofl.write("' " + line.slice(2, line.size-2).strip + "\n")
			elsif line.slice(0,1)=='(' && line.slice(-1,1)==')'
				@ofl.write('info "(' + line.slice(1, line.size-2).strip + ')"' + "\n")
			elsif line.index(':') != nil
				part = line.slice(0, line.index(':'))
				text = line.slice(part.size, line.size-part.size)

				part.strip!
				text.strip!

				charname = ''
				charpose = ''
				charwhere = ''
				charpers = ''

				if part != ''
					if part.index('(') != nil
						charname = part.slice(0, part.index('('))
						poses = part.slice(charname.size, part.size-charname.size).strip

						charname.strip!
						poses = poses.slice(1, poses.size-2).strip

						if poses != ''
							psarr = poses.split(/,/)
							charpose = psarr[0].strip
							charwhere = psarr[1].strip if psarr.size > 1
							charpers = psarr[2].strip if psarr.size > 2
						end
					else
						charname = part
					end
				end

				if charpose!=''
					@ofl.write("' [SHOW CHAR] name=\"#{charname}\" pose=\"#{charpose}\" position=\"#{charwhere}\" char=\"#{charpers}\"\n")
				end

				if text == ':-'
					while !ifl.eof
						line = ifl.readline.strip
						break if line == '-:'
						say(charname, line)
					end
				else
					say(charname, text.slice(1, text.size-1).strip)
				end
			elsif line.slice(-1,1) == '.'
				part = line.slice(0, line.size-1)

				charname = ''
				charpose = ''
				charwhere = ''
				charpers = ''

				if part != ''
					if part.index('(') != nil
						charname = part.slice(0, part.index('('))
						poses = part.slice(charname.size, part.size-charname.size).strip

						charname.strip!
						poses = poses.slice(1, poses.size-2).strip

						if poses != ''
							psarr = poses.split(/,/)
							charpose = psarr[0].strip
							charwhere = psarr[1].strip if psarr.size > 1
							charpers = psarr[2].strip if psarr.size > 2
						end
					else
						charname = part
					end
				end

				@ofl.write("' [SHOW CHAR] name=\"#{charname}\" pose=\"#{charpose}\" position=\"#{charwhere}\" char=\"#{charpers}\"\n")
			else
				@ofl.write("' [CONVERT ERROR] " + line + "\n")
			end
		end

		ifl.close
	end

	def convert(from, to)
		@ofl = File.open(to, 'wb')
		do_convert(from)
		@ofl.write("\ngame end\n")
		@ofl.close
	end
end

def run_it
#	if $*.size != 2
#		print "Usage: #{$0} from-script.nxt to-script.txt\n"
#		return
#	end
#
#	sc = ScriptConverter.new
#	sc.convert($*[0], $*[1])

	sc = ScriptConverter.new
	sc.convert('main.nxt', 'main.script')
end

run_it
